#include <iostream>

using namespace std;

class X {
  int i;
public:
  X( int k )
  {
      i = k;
      cout<<"X()\n";
  }
  void set(int ii) { i = ii; }
  int read()  { return i; }
  int permute() { return i = i * 47; }
};

class Y : public X {
  int i; // Different from X's i
public:
  Y(int m) : X(7+m)
  { i = m;
    cout<<"Y()\n";
  }
  int change() {
    i = permute(); // Different name call
    return i;
  }
  void set(int ii) {  // Redefine
    i = ii;
    X::set(ii); // Same-name function call
  }
};

int main() {
  cout << "sizeof(X) = " << sizeof(X) << endl;
  cout << "sizeof(Y) = " << sizeof(Y) << endl;
  Y  D(5);
  D.change();
  // X function interface comes through:
  D.read();
  D.permute();
  // Redefined functions hide base versions:
  D.set(12);
} ///:~
